package org.openjdk.gcbench.tests;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

class DimensionValues {
    Object[] values;

    public static List<DimensionValues> product(Dimension... dimensions) {
        List<DimensionValues> values = new ArrayList<>();

        for (Dimension d : dimensions) {
            List<DimensionValues> nextValues = new ArrayList<>();
            if (values.isEmpty()) {
                for (Object v : d.seq()) {
                    nextValues.add(new DimensionValues(new Object[]{v}));
                }
            } else {
                for (DimensionValues vs : values) {
                    for (Object v : d.seq()) {
                        nextValues.add(vs.addNew(v));
                    }
                }
            }
            values = nextValues;
        }
        return values;
    }


    public DimensionValues(Object[] values) {
        this.values = values;
    }

    DimensionValues addNew(Object value) {
        Object[] nv = Arrays.copyOf(values, values.length + 1);
        nv[nv.length - 1] = value;
        return new DimensionValues(nv);
    }
}
